# SmartAdmin for .NET Core

## Changelog

Please use the overview below to discover what has been changed and/or added between each update of **SmartAdmin for ASP.NET Core**.

### 4.3.2

1. Fixed Razor build error for '<--' comments
1. Added support for 'target' attribute in menu item links (e.g. `"target": "_blank"` in **nav.json**)
1. Fixed error that prevented '.\docs' from being updated
1. Removed obsolete Wiki references for documentation

### 4.3.1

1. Fixed Documentation routes for **Live Preview**
1. Fixed missing Color Palette panels
1. Fixed missing CSS variables
1. Fixed missing Sound Effects

## 4.3.0

1. Updated SmartAdmin Template to **v4.5.1**
1. Added Light and Dark mode Themes!
1. Updated the documentation
1. Updated plugins to latest supported versions
1. Updated FontAwesome Pro to 5.13 (incl. COVID-19)
1. Added Management for Users and Roles
1. Added support for link-able Parent menu items
1. Fixed various reported bugs
1. Improved error handling for JSON requests

### 4.2.2

1. Fixed Identity `_Layout` page for **Razor Pages**

### 4.2.1

1. Fixed Documentation routes for **Razor Pages**

## 4.2.0

1. Added **ASP.NET Core Razor Pages** flavor to the Theme!
1. Updated SmartAdmin Template to **v4.4.5**
1. Added Complete New and Improved Documentation to the Menu and the **/docs** folder of each Flavor
1. Replaced Navigation section with ViewComponent
1. Added support for HTML Entities in Navigation
1. Fixed links to Assets and Media
1. Added instruction on howto switch ASP.NET Core Identity to use `int` for Keys
1. Added instruction for fully renaming the Application and Project
1. Added instruction for using MySQL/Aurora as the data store

## 4.1.0

1. Updated SmartAdmin Template to **v4.4.2**
1. Added Instructions Page with Tutorials
   - How to Add Authorization to the Menu
   - How to Change Database to SQL Server 2012+
   - How to Enable Blazor Pages and Components
1. Fixed issue with Login Redirection when Hosting on Kestrel
1. Fixed issue with SmartAdmin Components not Loading on Seed

### 4.0.2

1. Updated Theme to .NET Core 3.1
1. Updated SmartAdmin Template to **v4.0.2**

### 4.0.1

1. Initial release for .NET Core 2.2
1. Updated SmartAdmin Template to **v4.0.1**

## 4.0.0

1. Initial release for .NET Core 2.1
1. Updated SmartAdmin Template to **v4.0.0**

---

Copyright &copy; 2020 by Walapa. All rights reserved. This documentation or any portion thereof
may not be reproduced or used in any manner whatsoever without the express written permission of the publisher except for the use of brief quotations in a review.
